diff -rN -u old-darcsweb/darcsweb.cgi new-darcsweb/darcsweb.cgi
--- old-darcsweb/darcsweb.cgi	2024-06-02 11:27:01.620310410 +0100
+++ new-darcsweb/darcsweb.cgi	2024-06-02 11:27:01.620310410 +0100
@@ -2288,441 +2573,445 @@
 <a href="%(myname)s?r=%(name)s;a=tree">tree</a>
 </td>
 </tr>
-		""" % {
-			'myname': config.myname,
-			'dname': name,
-			'name': urllib.quote(name),
-			'desc': shorten_str(desc, 60)
-		}
-	print "</table>"
-	print_footer(put_rss = 0)
+		"""
+            % {
+                "myname": config.myname,
+                "dname": name,
+                "name": urlescape(name),
+                "desc": shorten_str(desc, 60),
+            }
+        )
+    print("</table>")
+    print_footer(put_rss=0)
 
-def expand_multi_config(config):
-	"""Expand configuration entries that serve as "template" to others;
-	this make it easier to have a single directory with all the repos,
-	because they don't need specific entries in the configuration anymore.
-	"""
 
-	for conf in dir(config):
-		if conf.startswith('__'):
-			continue
-		c = config.__getattribute__(conf)
-		if 'multidir' not in dir(c):
-			continue
-
-		if not os.path.isdir(c.multidir):
-			continue
-
-		if 'exclude' not in dir(c):
-			c.exclude = []
-
-		entries = []
-		if 'multidir_deep' in dir(c) and c.multidir_deep:
-			for (root, dirs, files) in os.walk(c.multidir):
-				# do not visit hidden directories
-				dirs[:] = [d for d in dirs \
-						if not d.startswith('.')]
-				if '_darcs' in dirs:
-					p = root[1 + len(c.multidir):]
-					entries.append(p)
-		else:
-			entries = os.listdir(c.multidir)
-
-		entries.sort()
-		for name in entries:
-			name = name.replace('\\', '/')
-			if name.startswith('.'):
-				continue
-			fulldir = c.multidir + '/' + name
-			if not os.path.isdir(fulldir + '/_darcs'):
-				continue
-			if name in c.exclude:
-				continue
-
-			# set the display name at the beginning, so it can be
-			# used by the other replaces
-			if 'displayname' in dir(c):
-				dname = c.displayname % { 'name': name }
-			else:
-				dname = name
-
-			rep_dict = { 'name': name, 'dname': dname }
-
-			if 'autoexclude' in dir(c) and c.autoexclude:
-				dpath = fulldir + \
-					'/_darcs/third_party/darcsweb'
-				if not os.path.isdir(dpath):
-					continue
-
-			if 'autodesc' in dir(c) and c.autodesc:
-				dpath = fulldir + \
-					'/_darcs/third_party/darcsweb/desc'
-				if os.access(dpath, os.R_OK):
-					desc = open(dpath).readline().rstrip("\n")
-				else:
-					desc = c.repodesc % rep_dict
-			else:
-				desc = c.repodesc % rep_dict
-
-			if 'autourl' in dir(c) and c.autourl:
-				dpath = fulldir + \
-					'/_darcs/third_party/darcsweb/url'
-				if os.access(dpath, os.R_OK):
-					url = open(dpath).readline().rstrip("\n")
-				else:
-					url = c.repourl % rep_dict
-			else:
-				url = c.repourl % rep_dict
-
-			if 'autoprojurl' in dir(c) and c.autoprojurl:
-				dpath = fulldir + \
-					'/_darcs/third_party/darcsweb/projurl'
-				if os.access(dpath, os.R_OK):
-					projurl = open(dpath).readline().rstrip("\n")
-				elif 'repoprojurl' in dir(c):
-					projurl = c.repoprojurl % rep_dict
-				else:
-					projurl = None
-			elif 'repoprojurl' in dir(c):
-				projurl = c.repoprojurl % rep_dict
-			else:
-				projurl = None
-
-			rdir = fulldir
-			class tmp_config:
-				reponame = dname
-				repodir = rdir
-				repodesc = desc
-				repourl = url
-				repoencoding = c.repoencoding
-				repoprojurl = projurl
-
-				if 'footer' in dir(c):
-					footer = c.footer
-
-			# index by display name to avoid clashes
-			config.__setattr__(dname, tmp_config)
-
-def fill_config(name = None):
-	import config as all_configs
-	expand_multi_config(all_configs)
-
-	if name:
-		# we only care about setting some configurations if a repo was
-		# specified; otherwise we only set the common configuration
-		# directives
-		for conf in dir(all_configs):
-			if conf.startswith('__'):
-				continue
-			c = all_configs.__getattribute__(conf)
-			if 'reponame' not in dir(c):
-				continue
-			if c.reponame == name:
-				break
-		else:
-			# not found
-			raise Exception, "Repo not found: " + repr(name)
-
-	# fill the configuration
-	base = all_configs.base
-	if 'myname' not in dir(base):
-		# SCRIPT_NAME has the full path, we only take the file name
-		config.myname = os.path.basename(os.environ['SCRIPT_NAME'])
-	else:
-		config.myname = base.myname
-
-	if 'myurl' not in dir(base) and 'cachedir' not in dir(base):
-		n = os.environ['SERVER_NAME']
-		p = os.environ['SERVER_PORT']
-		s = os.path.dirname(os.environ['SCRIPT_NAME'])
-		u = os.environ.get('HTTPS', 'off') in ('on', '1')
-		if not u and p == '80' or u and p == '443':
-			p = ''
-		else:
-			p = ':' + p
-		config.myurl = 'http%s://%s%s%s' % (u and 's' or '', n, p, s)
-	else:
-		config.myurl = base.myurl
-
-	config.darcslogo = base.darcslogo
-	config.darcsfav = base.darcsfav
-	config.cssfile = base.cssfile
-	if name:
-		config.myreponame = config.myname + '?r=' + urllib.quote(name)
-		config.reponame = c.reponame
-		config.repodesc = c.repodesc
-		config.repodir = c.repodir
-		config.repourl = c.repourl
-
-		config.repoprojurl = None
-		if 'repoprojurl' in dir(c):
-			config.repoprojurl = c.repoprojurl
-
-		# repoencoding must be a tuple
-		if isinstance(c.repoencoding, str):
-			config.repoencoding = (c.repoencoding, )
-		else:
-			config.repoencoding = c.repoencoding
-
-	# optional parameters
-	if "darcspath" in dir(base):
-		config.darcspath = base.darcspath + '/'
-	else:
-		config.darcspath = ""
-
-	if "summary" in dir(base):
-		config.summary = base.summary
-	else:
-		config.summary = """
+def expand_multi_config(config):
+    """Expand configuration entries that serve as "template" to others;
+    this make it easier to have a single directory with all the repos,
+    because they don't need specific entries in the configuration anymore.
+    """
+
+    for conf in dir(config):
+        if conf.startswith("__"):
+            continue
+        c = config.__getattribute__(conf)
+        if "multidir" not in dir(c):
+            continue
+
+        if not os.path.isdir(c.multidir):
+            continue
+
+        if "exclude" not in dir(c):
+            c.exclude = []
+
+        entries = []
+        if "multidir_deep" in dir(c) and c.multidir_deep:
+            for (root, dirs, files) in os.walk(c.multidir):
+                # do not visit hidden directories
+                dirs[:] = [d for d in dirs if not d.startswith(".")]
+                if "_darcs" in dirs:
+                    p = root[1 + len(c.multidir) :]
+                    entries.append(p)
+        else:
+            entries = os.listdir(c.multidir)
+
+        entries.sort()
+        for name in entries:
+            name = name.replace("\\", "/")
+            if name.startswith("."):
+                continue
+            fulldir = c.multidir + "/" + name
+            if not os.path.isdir(fulldir + "/_darcs"):
+                continue
+            if name in c.exclude:
+                continue
+
+            # set the display name at the beginning, so it can be
+            # used by the other replaces
+            if "displayname" in dir(c):
+                dname = c.displayname % {"name": name}
+            else:
+                dname = name
+
+            rep_dict = {"name": name, "dname": dname}
+
+            if "autoexclude" in dir(c) and c.autoexclude:
+                dpath = fulldir + "/_darcs/third_party/darcsweb"
+                if not os.path.isdir(dpath):
+                    continue
+
+            if "autodesc" in dir(c) and c.autodesc:
+                dpath = fulldir + "/_darcs/third_party/darcsweb/desc"
+                if os.access(dpath, os.R_OK):
+                    desc = open(dpath).readline().rstrip("\n")
+                else:
+                    desc = c.repodesc % rep_dict
+            else:
+                desc = c.repodesc % rep_dict
+
+            if "autourl" in dir(c) and c.autourl:
+                dpath = fulldir + "/_darcs/third_party/darcsweb/url"
+                if os.access(dpath, os.R_OK):
+                    url = open(dpath).readline().rstrip("\n")
+                else:
+                    url = c.repourl % rep_dict
+            else:
+                url = c.repourl % rep_dict
+
+            if "autoprojurl" in dir(c) and c.autoprojurl:
+                dpath = fulldir + "/_darcs/third_party/darcsweb/projurl"
+                if os.access(dpath, os.R_OK):
+                    projurl = open(dpath).readline().rstrip("\n")
+                elif "repoprojurl" in dir(c):
+                    projurl = c.repoprojurl % rep_dict
+                else:
+                    projurl = None
+            elif "repoprojurl" in dir(c):
+                projurl = c.repoprojurl % rep_dict
+            else:
+                projurl = None
+
+            rdir = fulldir
+
+            class tmp_config:
+                reponame = dname
+                repodir = rdir
+                repodesc = desc
+                repourl = url
+                repoencoding = c.repoencoding
+                repoprojurl = projurl
+
+                if "footer" in dir(c):
+                    footer = c.footer
+
+            # index by display name to avoid clashes
+            config.__setattr__(dname, tmp_config)
+
+
+def fill_config(name=None):
+    import config as all_configs
+
+    expand_multi_config(all_configs)
+
+    if name:
+        # we only care about setting some configurations if a repo was
+        # specified; otherwise we only set the common configuration
+        # directives
+        for conf in dir(all_configs):
+            if conf.startswith("__"):
+                continue
+            c = all_configs.__getattribute__(conf)
+            if "reponame" not in dir(c):
+                continue
+            if c.reponame == name:
+                break
+        else:
+            # not found
+            raise Exception("Repo not found: " + repr(name))
+
+    # fill the configuration
+    base = all_configs.base
+    if "myname" not in dir(base):
+        # SCRIPT_NAME has the full path, we only take the file name
+        config.myname = os.path.basename(os.environ["SCRIPT_NAME"])
+    else:
+        config.myname = base.myname
+
+    if "myurl" not in dir(base) and "cachedir" not in dir(base):
+        n = os.environ["SERVER_NAME"]
+        p = os.environ["SERVER_PORT"]
+        s = os.path.dirname(os.environ["SCRIPT_NAME"])
+        u = os.environ.get("HTTPS", "off") in ("on", "1")
+        if not u and p == "80" or u and p == "443":
+            p = ""
+        else:
+            p = ":" + p
+        config.myurl = "http%s://%s%s%s" % (u and "s" or "", n, p, s)
+    else:
+        config.myurl = base.myurl
+
+    config.darcslogo = base.darcslogo
+    config.darcsfav = base.darcsfav
+    config.cssfile = base.cssfile
+    if name:
+        config.myreponame = config.myname + "?r=" + urlescape(name)
+        config.reponame = c.reponame
+        config.repodesc = c.repodesc
+        config.repodir = c.repodir
+        config.repourl = c.repourl
+
+        config.repoprojurl = None
+        if "repoprojurl" in dir(c):
+            config.repoprojurl = c.repoprojurl
+
+        # repoencoding must be a tuple
+        if isinstance(c.repoencoding, str):
+            config.repoencoding = (c.repoencoding,)
+        else:
+            config.repoencoding = c.repoencoding
+
+    # optional parameters
+    if "darcspath" in dir(base):
+        config.darcspath = base.darcspath + "/"
+    else:
+        config.darcspath = ""
+
+    if "summary" in dir(base):
+        config.summary = base.summary
+    else:
+        config.summary = """
 This is the repository index for a darcsweb site.<br/>
 These are all the available repositories.<br/>
 		"""
 
-	if "cachedir" in dir(base):
-		config.cachedir = base.cachedir
-	else:
-		config.cachedir = None
-
-	if "searchlimit" in dir(base):
-		config.searchlimit = base.searchlimit
-	else:
-		config.searchlimit = 100
-
-	if "logtimes" in dir(base):
-		config.logtimes = base.logtimes
-	else:
-		config.logtimes = None
-
-	if "url_links" in dir(base):
-		config.url_links = base.url_links
-	else:
-		config.url_links = ()
-
-	if name and "footer" in dir(c):
-		config.footer = c.footer
-	elif "footer" in dir(base):
-		config.footer = base.footer
-	else:
-		config.footer = "Crece desde el pueblo el futuro / " \
-				+ "crece desde el pie"
-	if "author_links" in dir(base):
-		config.author_links = base.author_links
-	else:
-		config.author_links = None
-	if "disable_annotate" in dir(base):
-		config.disable_annotate = base.disable_annotate
-	else:
-		config.disable_annotate = False
-
+    if "cachedir" in dir(base):
+        config.cachedir = base.cachedir
+    else:
+        config.cachedir = None
+
+    if "searchlimit" in dir(base):
+        config.searchlimit = base.searchlimit
+    else:
+        config.searchlimit = 100
+
+    if "logtimes" in dir(base):
+        config.logtimes = base.logtimes
+    else:
+        config.logtimes = None
+
+    if "url_links" in dir(base):
+        config.url_links = base.url_links
+    else:
+        config.url_links = ()
+
+    if name and "footer" in dir(c):
+        config.footer = c.footer
+    elif "footer" in dir(base):
+        config.footer = base.footer
+    else:
+        config.footer = (
+            "Crece desde el pueblo el futuro / " + "crece desde el pie"
+        )
+    if "author_links" in dir(base):
+        config.author_links = base.author_links
+    else:
+        config.author_links = None
+    if "disable_annotate" in dir(base):
+        config.disable_annotate = base.disable_annotate
+    else:
+        config.disable_annotate = False
+
+    if name and "readme" in dir(c):
+        config.readme = c.readme
+    elif "readme" in dir(base):
+        config.readme = base.readme
+    else:
+        config.readme = None
 
 
 #
 # main
 #
 
-if sys.version_info < (2, 3):
-	print "Sorry, but Python 2.3 or above is required to run darcsweb."
-	sys.exit(1)
-
-form = cgi.FieldStorage()
+# In Python 3.9.2, the ';' is no longer a valid separator by default, which
+# breaks the links we use. A new "separator" parameter is introduced to allow
+# to adjust this behaviour.
+if sys.version_info >= (3, 9, 2):
+    form = cgi.FieldStorage(errors="surrogateescape", separator=";")
+else:
+    form = cgi.FieldStorage(errors="surrogateescape")
 
 # if they don't specify a repo, print the list and exit
-if not form.has_key('r'):
-	fill_config()
-	do_listrepos()
-	log_times(cache_hit = 0, event = 'index')
-	sys.exit(0)
+if "r" not in form:
+    fill_config()
+    do_listrepos()
+    log_times(cache_hit=0, event="index")
+    sys.exit(0)
 
 # get the repo configuration and fill the config class
-current_repo = urllib.unquote(form['r'].value)
+current_repo = urllib.parse.unquote(form["r"].value)
 fill_config(current_repo)
 
 
 # get the action, or default to summary
-if not form.has_key("a"):
-	action = "summary"
+if "a" not in form:
+    action = "summary"
 else:
-	action = filter_act(form["a"].value)
+    action = filter_act(form["a"].value)
 
 # check if we have the page in the cache
 if config.cachedir:
-	url_request = os.environ['QUERY_STRING']
-	# create a string representation of the request, ignoring all the
-	# unused parameters to avoid DoS
-	params = ['r', 'a', 'f', 'h', 'topi', 'last']
-	params = [ x for x in form.keys() if x in params ]
-	url_request = [ (x, form[x].value) for x in params ]
-	url_request.sort()
-	cache = Cache(config.cachedir, url_request)
-	if cache.open():
-		# we have a hit, dump and run
-		cache.dump()
-		cache.close()
-		log_times(cache_hit = 1, repo = config.reponame)
-		sys.exit(0)
-	# if there is a miss, the cache will step over stdout, intercepting
-	# all "print"s and writing them to the cache file automatically
+    # create a string representation of the request, ignoring all the
+    # unused parameters to avoid DoS
+    params = ["r", "a", "f", "h", "topi", "last"]
+    params = [x for x in form.keys() if x in params]
+    url_request = [(x, form[x].value) for x in params]
+    url_request.sort()
+    cache = Cache(config.cachedir, url_request)
+    if cache.open():
+        # we have a hit, dump and run
+        cache.dump()
+        cache.close()
+        log_times(cache_hit=1, repo=config.reponame)
+        sys.exit(0)
+    # if there is a miss, the cache will step over stdout, intercepting
+    # all "print"s and writing them to the cache file automatically
 
 
 # see what should we do according to the received action
 if action == "summary":
-	do_summary()
+    do_summary()
 
 elif action == "commit":
-	phash = filter_hash(form["h"].value)
-	do_commit(phash)
+    phash = filter_hash(form["h"].value)
+    do_commit(phash)
 elif action == "commitdiff":
-	phash = filter_hash(form["h"].value)
-	do_commitdiff(phash)
+    phash = filter_hash(form["h"].value)
+    do_commitdiff(phash)
 elif action == "plain_commitdiff":
-	phash = filter_hash(form["h"].value)
-	do_plain_commitdiff(phash)
+    phash = filter_hash(form["h"].value)
+    do_plain_commitdiff(phash)
 elif action == "darcs_commitdiff":
-	phash = filter_hash(form["h"].value)
-	do_darcs_commitdiff(phash)
-elif action == "raw_commitdiff":
-	phash = filter_hash(form["h"].value)
-	do_raw_commitdiff(phash)
-
-elif action == 'headdiff':
-	phash = filter_hash(form["h"].value)
-	do_headdiff(phash)
+    phash = filter_hash(form["h"].value)
+    do_darcs_commitdiff(phash)
+
+elif action == "headdiff":
+    phash = filter_hash(form["h"].value)
+    do_headdiff(phash)
 elif action == "plain_headdiff":
-	phash = filter_hash(form["h"].value)
-	do_plain_headdiff(phash)
+    phash = filter_hash(form["h"].value)
+    do_plain_headdiff(phash)
 elif action == "darcs_headdiff":
-        phash = filter_hash(form["h"].value)
-        do_darcs_headdiff(phash)
+    phash = filter_hash(form["h"].value)
+    do_darcs_headdiff(phash)
 
 elif action == "filediff":
-	phash = filter_hash(form["h"].value)
-	fname = filter_file(form["f"].value)
-	do_filediff(phash, fname)
+    phash = filter_hash(form["h"].value)
+    fname = filter_file(form["f"].value)
+    do_filediff(phash, fname)
 elif action == "plain_filediff":
-	phash = filter_hash(form["h"].value)
-	fname = filter_file(form["f"].value)
-	do_plain_filediff(phash, fname)
+    phash = filter_hash(form["h"].value)
+    fname = filter_file(form["f"].value)
+    do_plain_filediff(phash, fname)
 elif action == "darcs_filediff":
-        phash = filter_hash(form["h"].value)
-	fname = filter_file(form["f"].value)
-	do_darcs_filediff(phash, fname)
-
-elif action == 'headfilediff':
-	phash = filter_hash(form["h"].value)
-	fname = filter_file(form["f"].value)
-	do_file_headdiff(phash, fname)
+    phash = filter_hash(form["h"].value)
+    fname = filter_file(form["f"].value)
+    do_darcs_filediff(phash, fname)
+
+elif action == "headfilediff":
+    phash = filter_hash(form["h"].value)
+    fname = filter_file(form["f"].value)
+    do_file_headdiff(phash, fname)
 elif action == "plain_headfilediff":
-	phash = filter_hash(form["h"].value)
-	fname = filter_file(form["f"].value)
-	do_plain_fileheaddiff(phash, fname)
+    phash = filter_hash(form["h"].value)
+    fname = filter_file(form["f"].value)
+    do_plain_fileheaddiff(phash, fname)
 elif action == "darcs_headfilediff":
-        phash = filter_hash(form["h"].value)
-	fname = filter_file(form["f"].value)
-        do_darcs_fileheaddiff(phash, fname)
+    phash = filter_hash(form["h"].value)
+    fname = filter_file(form["f"].value)
+    do_darcs_fileheaddiff(phash, fname)
 
 elif action == "annotate_normal":
-	fname = filter_file(form["f"].value)
-	if form.has_key("h"):
-		phash = filter_hash(form["h"].value)
-	else:
-		phash = None
-	do_annotate(fname, phash, "normal")
+    fname = filter_file(form["f"].value)
+    if "h" in form:
+        phash = filter_hash(form["h"].value)
+    else:
+        phash = None
+    do_annotate(fname, phash, "normal")
 elif action == "annotate_plain":
-	fname = filter_file(form["f"].value)
-	if form.has_key("h"):
-		phash = filter_hash(form["h"].value)
-	else:
-		phash = None
-        do_annotate_plain(fname, phash)
+    fname = filter_file(form["f"].value)
+    if "h" in form:
+        phash = filter_hash(form["h"].value)
+    else:
+        phash = None
+    do_annotate_plain(fname, phash)
 elif action == "annotate_zebra":
-	fname = filter_file(form["f"].value)
-	if form.has_key("h"):
-		phash = filter_hash(form["h"].value)
-	else:
-		phash = None
-	do_annotate(fname, phash, "zebra")
+    fname = filter_file(form["f"].value)
+    if "h" in form:
+        phash = filter_hash(form["h"].value)
+    else:
+        phash = None
+    do_annotate(fname, phash, "zebra")
 elif action == "annotate_shade":
-	fname = filter_file(form["f"].value)
-	if form.has_key("h"):
-		phash = filter_hash(form["h"].value)
-	else:
-		phash = None
-	do_annotate(fname, phash, "shade")
+    fname = filter_file(form["f"].value)
+    if "h" in form:
+        phash = filter_hash(form["h"].value)
+    else:
+        phash = None
+    do_annotate(fname, phash, "shade")
 
 elif action == "shortlog":
-	if form.has_key("topi"):
-		topi = int(filter_num(form["topi"].value))
-	else:
-		topi = 0
-	if form.has_key("last"):
-		last = int(filter_num(form["last"].value))
-	else:
-		last = PATCHES_PER_PAGE
-	do_shortlog(topi=topi,last=last)
+    if "topi" in form:
+        topi = int(filter_num(form["topi"].value))
+    else:
+        topi = 0
+    if "last" in form:
+        last = int(filter_num(form["last"].value))
+    else:
+        last = PATCHES_PER_PAGE
+    do_shortlog(topi=topi, last=last)
 
 elif action == "filehistory":
-	if form.has_key("topi"):
-		topi = int(filter_num(form["topi"].value))
-	else:
-		topi = 0
-	fname = filter_file(form["f"].value)
-	if form.has_key("last"):
-		last = int(filter_num(form["last"].value))
-	else:
-		last = PATCHES_PER_PAGE
-	do_filehistory(topi, fname, last=last)
+    if "topi" in form:
+        topi = int(filter_num(form["topi"].value))
+    else:
+        topi = 0
+    fname = filter_file(form["f"].value)
+    if "last" in form:
+        last = int(filter_num(form["last"].value))
+    else:
+        last = PATCHES_PER_PAGE
+    do_filehistory(topi, fname, last=last)
 
 elif action == "log":
-	if form.has_key("topi"):
-		topi = int(filter_num(form["topi"].value))
-	else:
-		topi = 0
-	if form.has_key("last"):
-		last = int(filter_num(form["last"].value))
-	else:
-		last = PATCHES_PER_PAGE
-	do_log(topi, last=last)
-
-elif action == 'headblob':
-	fname = filter_file(form["f"].value)
-	do_headblob(fname)
-
-elif action == 'plainblob':
-	fname = filter_file(form["f"].value)
-	do_plainblob(fname)
-
-elif action == 'tree':
-	if form.has_key('f'):
-		fname = filter_file(form["f"].value)
-	else:
-		fname = '/'
-	do_tree(fname)
-
-elif action == 'rss':
-	do_rss()
-
-elif action == 'atom':
-	do_atom()
-
-elif action == 'search':
-	if form.has_key('s'):
-		s = form["s"].value
-	else:
-		s = ''
-	do_search(s)
-	if config.cachedir:
-		cache.cancel()
+    if "topi" in form:
+        topi = int(filter_num(form["topi"].value))
+    else:
+        topi = 0
+    if "last" in form:
+        last = int(filter_num(form["last"].value))
+    else:
+        last = PATCHES_PER_PAGE
+    do_log(topi, last=last)
+
+elif action == "headblob":
+    fname = filter_file(form["f"].value)
+    do_headblob(fname)
+
+elif action == "plainblob":
+    fname = filter_file(form["f"].value)
+    do_plainblob(fname)
+
+elif action == "tree":
+    if "f" in form:
+        fname = filter_file(form["f"].value)
+    else:
+        fname = "/"
+    do_tree(fname)
+
+elif action == "rss":
+    do_rss()
+
+elif action == "atom":
+    do_atom()
+
+elif action == "search":
+    if "s" in form:
+        s = form["s"].value
+    else:
+        s = ""
+    do_search(s)
+    if config.cachedir:
+        cache.cancel()
 
 else:
-	action = "invalid query"
-	do_die()
-	if config.cachedir:
-		cache.cancel()
+    action = "invalid query"
+    do_die()
+    if config.cachedir:
+        cache.cancel()
 
 
 if config.cachedir:
-	cache.close()
-
-log_times(cache_hit = 0, repo = config.reponame)
-
+    cache.close()
 
+log_times(cache_hit=0, repo=config.reponame)
diff -rN -u old-darcsweb/indent.sh new-darcsweb/indent.sh
--- old-darcsweb/indent.sh	1970-01-01 01:00:00.000000000 +0100
+++ new-darcsweb/indent.sh	2024-06-02 11:27:01.620310410 +0100
@@ -0,0 +1,4 @@
+#!/bin/bash
+
+# Reformat the code to keep an uniform coding style.
+exec black -l 79 darcsweb.cgi mkconfig.py
diff -rN -u old-darcsweb/mkconfig.py new-darcsweb/mkconfig.py
--- old-darcsweb/mkconfig.py	2024-06-02 11:27:01.620310410 +0100
+++ new-darcsweb/mkconfig.py	2024-06-02 11:27:01.620310410 +0100
@@ -1,4 +1,4 @@
-#!/usr/bin/env python
+#!/usr/bin/env python3
 
 """
 A darcsweb configuration generator
@@ -27,39 +27,40 @@
 import sys
 import os
 import string
-import urllib
+import urllib.parse
 
 
 def help():
-	print "Error: wrong parameter count"
-	print __doc__
+    print("Error: wrong parameter count")
+    print(__doc__)
+
 
 def filter_class(s):
-	"Filter s so the new string can be used as a class name."
-	allowed = string.ascii_letters + string.digits + '_'
-	l = [c for c in s if c in allowed]
-	return string.join(l, "")
+    "Filter s so the new string can be used as a class name."
+    allowed = string.ascii_letters + string.digits + "_"
+    l = [c for c in s if c in allowed]
+    return string.join(l, "")
+
 
 def filter_url(s):
-	"Filter s so the new string can be used in a raw url."
-	return urllib.quote_plus(s, ':/')
+    "Filter s so the new string can be used in a raw url."
+    return urllib.parse.quote_plus(s, ":/")
 
 
 # check parameters
 if len(sys.argv) != 5:
-	help()
-	sys.exit(0)
+    help()
+    sys.exit(0)
 
 myself, baseurl, basedesc, baseencoding, basepath = sys.argv
 
 dirs = os.listdir(basepath)
 for d in dirs:
-	path = basepath + '/' + d
-	if not os.path.isdir(path + '/_darcs'):
-		# not a repo, skip
-		continue
-	s = \
-"""
+    path = basepath + "/" + d
+    if not os.path.isdir(path + "/_darcs"):
+        # not a repo, skip
+        continue
+    s = """
 class %(classname)s:
 	reponame = '%(name)s'
 	repodesc = '%(desc)s'
@@ -67,12 +68,11 @@
 	repourl = '%(url)s'
 	repoencoding = '%(encoding)s'
 """ % {
-		'classname': filter_class(d),
-		'name': d,
-		'desc': basedesc.replace('NAME', d),
-		'dir': os.path.abspath(basepath + '/' + d),
-		'url': filter_url(baseurl.replace('NAME', d)),
-		'encoding': baseencoding,
-	}
-	print s
-
+        "classname": filter_class(d),
+        "name": d,
+        "desc": basedesc.replace("NAME", d),
+        "dir": os.path.abspath(basepath + "/" + d),
+        "url": filter_url(baseurl.replace("NAME", d)),
+        "encoding": baseencoding,
+    }
+    print(s)
diff -rN -u old-darcsweb/pyproject.toml new-darcsweb/pyproject.toml
--- old-darcsweb/pyproject.toml	1970-01-01 01:00:00.000000000 +0100
+++ new-darcsweb/pyproject.toml	2024-06-02 11:27:01.620310410 +0100
@@ -0,0 +1,5 @@
+# Black is used to auto-format the code.
+[tool.black]
+line-length = 79
+include = '/(darcsweb.cgi|mkconfig.py)$'
+
